<script context="module">function traverseNodes(tree, nodes, parentNodeId) {
  nodes.forEach((nodeId) => {
    const node = tree[nodeId];
    if (!node)
      return;
    node.parentNodeId = parentNodeId;
    if (node.children?.length) {
      traverseNodes(tree, node.children, node.id);
    }
  });
}
</script>

<script>import { createEventDispatcher } from "svelte";
import TreeNode from "./TreeNode.svelte";
export let tree;
export let collapseControlled = false;
export let treeClass = "";
export let treeNodeClass = "";
export let childrenContainerClass = "";
export let childPaddingLeft = "1rem";
const emit = createEventDispatcher();
traverseNodes(tree, tree.children);
function handleNodeClick(event) {
  const { node, collapsed } = event.detail;
  if (!collapseControlled) {
    tree[node.id].collapsed = collapsed;
  }
  emit("node-click", event.detail);
}
</script>

<div class={'tree-view ' + treeClass}>
	{#each tree.children as nodeId (nodeId)}
		<div>
			<TreeNode
				{tree}
				node={tree[nodeId]}
				{collapseControlled}
				{treeNodeClass}
				{childrenContainerClass}
				{childPaddingLeft}
				on:node-click={handleNodeClick}
			/>
		</div>
	{/each}
</div>
